VERSION 4.00
Begin VB.Form frmResource 
   Caption         =   "Resource Browser"
   ClientHeight    =   3900
   ClientLeft      =   1095
   ClientTop       =   1515
   ClientWidth     =   5025
   Height          =   4305
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   3900
   ScaleWidth      =   5025
   Top             =   1170
   Width           =   5145
   Begin VB.ListBox lstNames 
      Height          =   1590
      Left            =   2520
      TabIndex        =   4
      Top             =   2220
      Width           =   2235
   End
   Begin VB.ListBox lstTypes 
      Height          =   1590
      Left            =   180
      TabIndex        =   3
      Top             =   2220
      Width           =   2175
   End
   Begin VB.FileListBox File1 
      Height          =   1590
      Left            =   2520
      TabIndex        =   2
      Top             =   180
      Width           =   2235
   End
   Begin VB.DirListBox Dir1 
      Height          =   1155
      Left            =   180
      TabIndex        =   1
      Top             =   600
      Width           =   2175
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   180
      TabIndex        =   0
      Top             =   180
      Width           =   2175
   End
   Begin Cbkd.Callback cbkNames 
      Left            =   1080
      Top             =   1860
      _Version        =   262144
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      Type            =   24
   End
   Begin Cbkd.Callback Callback1 
      Left            =   300
      Top             =   1860
      _Version        =   262144
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      Type            =   23
   End
End
Attribute VB_Name = "frmResource"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
' Note - Only sees resources for 32 bit files.
Option Explicit
' Copyright  1997 by Desaware Inc. All Rights Reserved

Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Private Declare Function EnumResourceNames Lib "kernel32" Alias "EnumResourceNamesA" (ByVal hModule As Long, ByVal lpType As String, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function EnumResourceNamesById Lib "kernel32" Alias "EnumResourceNamesA" (ByVal hModule As Long, ByVal lpType As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function EnumResourceTypes Lib "kernel32" Alias "EnumResourceTypesA" (ByVal hModule As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function LoadLibraryEx Lib "kernel32" Alias "LoadLibraryExA" (ByVal lpLibFileName As String, ByVal hFile As Long, ByVal dwFlags As Long) As Long
Private Const LOAD_LIBRARY_AS_DATAFILE = 2
Private Const RT_CURSOR = 1&
Private Const RT_BITMAP = 2&
Private Const RT_ICON = 3&
Private Const RT_MENU = 4&
Private Const RT_DIALOG = 5&
Private Const RT_STRING = 6&
Private Const RT_FONTDIR = 7&
Private Const RT_FONT = 8&
Private Const RT_ACCELERATOR = 9&
Private Const RT_RCDATA = 10&
Private Const RT_MESSAGETABLE = 11
Private Const RT_GROUP_CURSOR = 12
Private Const RT_GROUP_ICON = 14
Private Const RT_VERSION = 16
Private Const RT_DLGINCLUDE = 17
Private Const RT_PLUGPLAY = 19
Private Const RT_VXD = 20

Dim modulehandle&

' This callback represents the EnumResourceTypes callback
' lval1 is the module handle.
' lval2 is the type.
' lval3 is user defined.
Private Sub Callback1_cbxLLL(lval1 As Long, lval2 As Long, lval3 As Long, retval As Long)
    ' If the high word is zero, this is a standard
    ' resource type.
    If (lval2 And &HFFFF0000) = 0 Then
        Select Case lval2
            Case RT_CURSOR
                lstTypes.AddItem "Cursors"
            Case RT_BITMAP
                lstTypes.AddItem "Bitmaps"
            Case RT_ICON
                lstTypes.AddItem "Icons"
            Case RT_MENU
                lstTypes.AddItem "Menu"
            Case RT_DIALOG
                lstTypes.AddItem "Dialog"
            Case RT_STRING
                lstTypes.AddItem "String"
            Case RT_FONTDIR
                lstTypes.AddItem "Font Directory"
            Case RT_FONT
                lstTypes.AddItem "Font"
            Case RT_ACCELERATOR
                lstTypes.AddItem "Accelerator"
            Case RT_RCDATA
                lstTypes.AddItem "RCData"
            Case RT_MESSAGETABLE
                lstTypes.AddItem "Message Table"
            Case RT_GROUP_CURSOR
                lstTypes.AddItem "Cursor (hardware independent)"
            Case RT_GROUP_ICON
                lstTypes.AddItem "Icon (hardware independent)"
            Case RT_VERSION
                lstTypes.AddItem "Version"
            Case RT_PLUGPLAY
                lstTypes.AddItem "Plug & Play Info"
            Case Else
                lstTypes.AddItem Hex$(lval2)
        End Select
        lstTypes.ItemData(lstTypes.NewIndex) = lval2
    Else    ' The resource type is defined by a string
        lstTypes.AddItem agGetStringFromPointer(lval2)
        lstTypes.ItemData(lstTypes.NewIndex) = 0
    End If
    retval = True

End Sub

' The cbkNames callback is used for EnumResourceNames
' lval1 is the module handle
' lval2 is the resource type
' lval3 is the resource name or id
' lval4 is user defined
Private Sub cbkNames_cbxLLLL(lval1 As Long, lval2 As Long, lval3 As Long, lval4 As Long, retval As Long)
    ' The resource has a name or identifier depending on whether
    ' the high word is zero.
    If (lval3 And &HFFFF0000) <> 0 Then
        ' Show the resource name
        lstNames.AddItem agGetStringFromPointer(lval3)
    Else
        ' Show the resource Identifier
        lstNames.AddItem Hex$(lval3)
    End If
    retval = True
End Sub

Private Sub Dir1_Change()
    File1.Path = Dir1.Path
End Sub

Private Sub Drive1_Change()
    Dir1.Path = Drive1.Drive

End Sub

Private Sub File1_Click()
    Dim res&
    ' Free the previous library if present
    If modulehandle <> 0 Then
        Call FreeLibrary(modulehandle)
    End If
    ' Load in the file into the address space, but don't allow it to
    ' execute (including initialization code).
    modulehandle = LoadLibraryEx(Dir1.Path & "\" & File1.filename, 0, LOAD_LIBRARY_AS_DATAFILE)
    lstTypes.Clear
    lstNames.Clear
    ' Start by enumerating the types of resources in the file
    If modulehandle <> 0 Then res = EnumResourceTypes(modulehandle, Callback1.ProcAddress, 0)
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' Clean up when done.
    If modulehandle <> 0 Then
        Call FreeLibrary(modulehandle)
    End If

End Sub

Private Sub lstTypes_Click()
    Dim usetype&
    Dim res&
    Dim usestring$
    If lstTypes.ListCount = 0 Or modulehandle = 0 Then Exit Sub
    usetype = lstTypes.ItemData(lstTypes.ListIndex)
    lstNames.Clear
    ' We have two aliases for the EnumResourceNames function, one which
    ' takes a numeric resource type, the other which takes a
    ' resource type string
    If usetype = 0 Then
        usestring = lstTypes.List(lstTypes.ListIndex)
        res = EnumResourceNames(modulehandle, usestring, cbkNames.ProcAddress, 0)
    Else
        res = EnumResourceNamesById(modulehandle, usetype, cbkNames.ProcAddress, 0)
    End If
End Sub
